<template>
  <!--    @keydown.tab="onKeyPressSearch" -->
  <!--    @keyup.enter="onKeyPressSearch" -->
  <div class="flex flex-col relative pt-4">
    <Button
      v-if="selected && selected.length > 0"
      class="!absolute !py-0 top-[-0.2rem] right-0 !text-xs"
      text
      size="small"
      @click="onResetClick"
    >
      zurücksetzen
    </Button>
    <label :for="'input-' + field" class="absolute -top-0.5 left-2 text-xs text-gray-700 font-semibold">{{ label }}</label>
    <AutoComplete
      ref="ac"
      v-model="selected"
      :inputId="'input-' + field"
      :suggestions="options"
      multiple
      fluid
      optionLabel="value"
      dataKey="value"
      emptySearchMessage="Keine Ergebnisse gefunden"
      :placeholder="placeholder"
      @keyup.enter="onKeyPressSearch"
      @complete="complete"
      @change="change"
      @blur="blur"
      :pt="{
        overlay: {
          class: { 'hidden': !this.showSuggestions }
        }
      }"
    >
      <template #option="props">
        <span v-if="props.option.name" v-html="props.option.name"></span>
      </template>
    </AutoComplete>
  </div>
</template>
<script>
import AutoComplete from 'primevue/autocomplete';
export default {
  name: 'SearchInput',
  components: {
    AutoComplete
  },
  props: {
    field: {
      default: null,
    },
    label: {
      default: '',
    },
    placeholder: {
      default: '',
    },
    showNoOptions: {
      default: false,
    },
    showSuggestions: {
      default: true,
    },
    floatingLabel: {
      default: true,
    },
    openDirection: {
      default: 'bottom',
    },
  },
  data () {
    return {
      loading: false,
      suggestions: [],
      selected: null,
      options: [],
      lastInput: '',
      firstOptionHidden: true,
    };
  },
  computed: {
    _placeholder () {
      return this.selected.length > 0 ? 'Bitte eingeben...' : this.placeholder;
    },
    monasteriesQuery () {
      return this.$store.state.monasteriesQuery;
    },
  },
  methods: {
    change({ value }) {
      this.lastInput = ''; //hinders onKeyPressSearch to also emitSearch when pressing enter on a suggestion
      this.emitSearch();
    },
    complete ({ query }) {
      if (query !== '') {
        this.$emit('change', query);
        this.lastInput = query;
        if (this.showSuggestions && !this.loading) {
          this.loading = true;
          this.$store.dispatch('getSuggestions', { field: this.field, value: query })
            .then(suggestions => {
              if (suggestions) {
                this.options = suggestions.map(suggestion => ({
                  name: suggestion.termHighlighted,
                  value: suggestion.term,
                })).sort((a) => {
                  // If an option equals the last input then put it on top.
                  return this.lastInput.toLowerCase() === a.value.toLowerCase() ? -1 : 1;
                });
              }
              this.loading = false;
            });
        }
        else {
          //otherwise input fields without suggestions will get stuck in a loading state, see https://github.com/primefaces/primevue/issues/5601#issuecomment-2076067073
          this.options = [...this.options];
        }
      }
    },
    blur(event) {
      //enable search by mouse click for fields without suggestions
      if (!this.showSuggestions) {
        this.onKeyPressSearch();
      }
      event.target.value = ''
    },
    onKeyPressSearch () {
      if (this.lastInput !== '') {
        this.selected = [...(this.selected ? this.selected : []), {
          name: this.lastInput,
          value: this.lastInput,
        }];
        this.lastInput = '';
        this.emitSearch();
      }
    },
    emitSearch () {
      this.$emit('search', this.selected.map(s => s.value));
    },
    onResetClick () {
      this.reset();
      this.emitSearch();
    },
    reset () {
      this.selected = [];
      this.options = [];
      this.lastInput = '';
    },
  },
  watch: {
    selected: {
      handler: function (value) {
        this.$refs.ac.rootEl.querySelector('input').value = ''
      }
    },
    // Watch the global search query to enable "reset all" functionality
    monasteriesQuery: {
      handler: function (query) {
        if (query.search === null) {
          this.reset();
        }
      },
      immediate: false
    },
  },
};
</script>

<style lang="scss" scoped>
.p-floatlabel:has(input:focus),
.p-floatlabel:has(input.p-filled),
.p-floatlabel:has(input:-webkit-autofill),
.p-floatlabel:has(textarea:focus),
.p-floatlabel:has(textarea.p-filled),
.p-floatlabel:has(.p-inputwrapper-focus),
.p-floatlabel:has(.p-inputwrapper-filled) {
  label {
    top: -0.7rem;
  }
}

.p-chip-label {
  @apply leading-5;
}


:deep(.p-autocomplete-input-chip input) {
  @apply leading-5;
  &::placeholder {
    @apply text-gray-400 text-[0.9rem] #{!important};
    font-weight: 300 !important;
  }
}
</style>
